<id>TestingMonkey:ssi_topicNews</id>
<version>0.8</version>
<author>TestingMonkey</author>
<homepage>http://www.irconcepts.net</homepage>

<edit file>
$boarddir/SSI.php
</edit file>

<search for>
?>
</search for>

<add before>

// Show the latest news, with a template... by topic.
function ssi_topicNews($topic = null, $limit = null, $start = null, $length = null, $link = null, $output_method = 'echo')
{
	global $scripturl, $db_prefix, $txt, $settings, $modSettings, $context, $func;

	loadLanguage('Stats');
	
	$board = null;
	
	// Must be integers....
	if ($topic == null)
		$topic = (int) '2';
	elseif($topic == '1')
		$topic = (int) '2';
	else 
		$topic = (int) $topic;
			
	if ($limit === null)
		$limit = isset($_GET['limit']) ? (int) $_GET['limit'] : 10;
	else
		$limit = (int) $limit;

	if ($start === null)
		$start = isset($_GET['start']) ? (int) $_GET['start'] : 0;
	else
		$start = (int) $start;

	if ($board !== null)
		$board = (int) $board;
	elseif (isset($_GET['board']))
		$board = (int) $_GET['board'];

	if ($length === null)
		$length = isset($_GET['length']) ? (int) $_GET['length'] : 0;
	else
		$length = (int) $length;

	// Make sure guests can see this board.
	$request = db_query("
		SELECT ID_BOARD
		FROM {$db_prefix}boards
		WHERE " . ($board === null ? '' : "ID_BOARD = $board
			AND ") . "FIND_IN_SET(-1, memberGroups)
		LIMIT 1", __FILE__, __LINE__);
	if (mysql_num_rows($request) == 0)
	{
		if ($output_method == 'echo')
			die($txt['smf_news_error2']);
		else
			return array();
	}
	list ($board) = mysql_fetch_row($request);
	mysql_free_result($request);

	// Find the posts.
	$request = db_query("
		SELECT
			m.icon, m.subject, m.body, IFNULL(mem.realName, m.posterName) AS posterName, m.posterTime,
			t.numReplies, t.ID_TOPIC, m.ID_MEMBER, m.smileysEnabled
		FROM ({$db_prefix}topics AS t, {$db_prefix}messages AS m)
			LEFT JOIN {$db_prefix}members AS mem ON (mem.ID_MEMBER = m.ID_MEMBER)
		WHERE t.ID_TOPIC = $topic
			AND m.ID_MSG = t.ID_FIRST_MSG
		ORDER BY m.ID_MSG DESC
		LIMIT $start, $limit", __FILE__, __LINE__);
	$return = array();
	while ($row = mysql_fetch_assoc($request))
	{
		$row['body'] = parse_bbc($row['body'], $row['smileysEnabled'], $row['ID_TOPIC']);
		// If we want to limit the length of the post.
		if (!empty($length) && $func['strlen']($row['body']) > $length)
		{
			$row['body'] = $func['substr']($row['body'], 0, $length);
			$row['body'] = trim($row['body']);
			$row['body'] = join(' ', array_slice (explode(' ', $row['body']), 0, strlen($row['body']))); 
			$pos = max(strrpos($row['body'], ' '), strrpos($row['body'], '<'));
			if($pos !== null){
				$row['body'] = $func['substr']($row['body'], 0, $pos);
			}
			if($link !== null){
				$row['body'] .= '<div class="smalltext" style="margin-top: 1ex; font-weight: bold;">';
				$row['body'] .=	'<a href="';
				$row['body'] .=	$link;
				$row['body'] .=	'" title="Full Story">Read more...</a>';
				$row['body'] .= '</div>';
			} else {
				$row['body'] = $row['body'] . '...';
			}
		}


		// Check that this message icon is there...
		if (empty($modSettings['messageIconChecks_disable']) && !isset($icon_sources[$row['icon']]))
			$icon_sources[$row['icon']] = file_exists($settings['theme_dir'] . '/images/post/' . $row['icon'] . '.gif') ? 'images_url' : 'default_images_url';

		censorText($row['subject']);
		censorText($row['body']);

		$return[] = array(
			'id' => $row['ID_TOPIC'],
			'icon' => '<img src="' . $settings['images_url'] . '/post/' . $row['icon'] . '.gif" align="middle" alt="' . $row['icon'] . '" />',
			'subject' => $row['subject'],
			'time' => timeformat($row['posterTime']),
			'timestamp' => $row['posterTime'],
			'body' => $row['body'],
			'href' => $scripturl . '?topic=' . $row['ID_TOPIC'] . '.0',
			'link' => '<a href="' . $scripturl . '?topic=' . $row['ID_TOPIC'] . '.0">' . $row['numReplies'] . ' ' . ($row['numReplies'] == 1 ? $txt['smf_news_1'] : $txt['smf_news_2']) . '</a>',
			'replies' => $row['numReplies'],
			'new_comment' => '<a href="' . $scripturl . '?action=post;topic=' . $row['ID_TOPIC'] . '.' . $row['numReplies'] . '">' . $txt['smf_news_3'] . '</a>',
			'poster' => array(
				'id' => $row['ID_MEMBER'],
				'name' => $row['posterName'],
				'href' => !empty($row['ID_MEMBER']) ? $scripturl . '?action=profile;u=' . $row['ID_MEMBER'] : '',
				'link' => !empty($row['ID_MEMBER']) ? '<a href="' . $scripturl . '?action=profile;u=' . $row['ID_MEMBER'] . '">' . $row['posterName'] . '</a>' : $row['posterName']
			),
			'is_last' => false
		);
	}
	mysql_free_result($request);

	if (empty($return))
		return $return;

	$return[count($return) - 1]['is_last'] = true;

	if ($output_method != 'echo')
		return $return;

	foreach ($return as $news)
	{
		echo '
		<div class="tborder">
			<table cellpadding="4" cellspacing="0" border="0" width="100%" align="center">
				<tr>
					<td valign="middle" align="right" width="22">
						', $news['icon'], '
					</td>
					<td align="left" style="padding-left: 8px;">
						<div style="font-family: Tahoma; line-height: 1.3em;">
							 ', $news['subject'], '
						</div>
					</td>
				</tr>
				<tr>
					<td colspan="2">
						<div style="line-height: 1.3em; font-family: Tahoma;">
								', $news['body'], '
						</div>
					</td>
				</tr>
				<tr>
					<td align="center" colspan="2">
						<font style="font-size: 11px">', $news['link'], ' | ', $news['new_comment'], ' | ', $news['time'], ' | ', $news['poster']['link'], '</font>
					</td>
				</tr>
			</table>
		</div>';

		if (!$news['is_last'])
			echo '
			<hr width="100%" />
			<br />';
	}
}

</add before>